#ifndef BLOBS_GFX_X_H_INCLUDED
#define BLOBS_GFX_X_H_INCLUDED

#define MAX_RESOLUTION 4096
#define MIN_RESOLUTION 16

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#define GFX_ADD_PIXEL(G,X,Y,P) G->cbuffer[X+Y*G->xres] = G->cbuffer[X+Y*G->xres]+P>255?255:G->cbuffer[X+Y*G->xres]+P
//((int)(P + G->cbuffer[X+Y*G->xres]))&0xff;
//#define GFX_ADD_PIXEL(G,X,Y,P) G->cbuffer[X+Y*G->xres]=P;

#ifdef USE_XSHM_EXT
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#endif

/* required for fps details */
#include <sys/time.h>

typedef struct {
  Display *dpy;
  int xres,yres; /* Display resolutions */
  XVisualInfo xvs;
  int rootwin;
  Window win;
  GC gc;
  int renderer;  /* if set uses an alternative renderer */
  XImage *xim;            /* screen / front buffer   */
  unsigned char *cbuffer; /* char (8bit) back buffer */
  unsigned long simple_map[256]; /* A simple colour map. */
  unsigned long base_colour;
  int default_xres, default_yres;
  int xoff,yoff; /* where to put the image in the window */
#ifdef USE_XSHM_EXT
  XShmSegmentInfo shminfo;
#endif
} Gfx;

int  gfx_get_best_truecolor(Gfx *g);
int  gfx_SetupGfx(Gfx *g);
int  gfx_getkey(Gfx *g);

void gfx_create_cmap(Gfx *gf);
void gfx_Print_Visual_Info(XVisualInfo *v);
void gfx_display_image(Gfx *g);
void gfx_cleanup(Gfx *g);
//void gfx_add_pixel(Gfx *g, int x, int y, unsigned char pixval);
#endif /* BLOBS_GFX_X_H_INCLUDED */

void render_blurred_buffer(Gfx *g);
